package ir.tasks.twelve.c;

import static org.junit.Assert.assertEquals;
import ir.tasks.twelve.a.Frequency;
import ir.tasks.twelve.a.Utilities;

import java.io.File;
import java.util.List;

import org.junit.Test;

public class TwoGramFrequencyCounterTest {

	@Test
	public void test() {
		File file = new File("test/in_01.txt");
		List<String> words = Utilities.tokenizeFile(file);
		List<Frequency> f = TwoGramFrequencyCounter.computeTwoGramFrequencies(words);
		Utilities.printFrequencies(f);
		assertEquals(25, f.size());
		assertEquals("a b", f.get(0).getText());
		assertEquals(1, f.get(0).getFrequency());
		assertEquals("m n", f.get(12).getText());
		assertEquals(1, f.get(12).getFrequency());
		assertEquals("y z", f.get(24).getText());
		assertEquals(1, f.get(24).getFrequency());

		file = new File("test/in_02.txt");
		words = Utilities.tokenizeFile(file);
		f = TwoGramFrequencyCounter.computeTwoGramFrequencies(words);
		Utilities.printFrequencies(f);
		assertEquals(25, f.size());
		assertEquals("aa bb", f.get(0).getText());
		assertEquals(1, f.get(0).getFrequency());
		assertEquals("mm nn", f.get(12).getText());
		assertEquals(1, f.get(12).getFrequency());
		assertEquals("yy zz", f.get(24).getText());
		assertEquals(1, f.get(24).getFrequency());

		file = new File("test/in_03.txt");
		words = Utilities.tokenizeFile(file);
		f = TwoGramFrequencyCounter.computeTwoGramFrequencies(words);
		Utilities.printFrequencies(f);
		assertEquals(248, f.size());
		assertEquals("can not", f.get(0).getText());
		assertEquals(3, f.get(0).getFrequency());
		assertEquals("shall not", f.get(12).getText());
		assertEquals(2, f.get(12).getFrequency());
		assertEquals("years ago", f.get(247).getText());
		assertEquals(1, f.get(247).getFrequency());

		file = new File("test/in_04.txt");
		words = Utilities.tokenizeFile(file);
		f = TwoGramFrequencyCounter.computeTwoGramFrequencies(words);
		Utilities.printFrequencies(f);
		assertEquals(46, f.size());
		assertEquals("0 1", f.get(0).getText());
		assertEquals(1, f.get(0).getFrequency());
		assertEquals("but if", f.get(12).getText());
		assertEquals(1, f.get(12).getFrequency());
		assertEquals("you don", f.get(45).getText());
		assertEquals(1, f.get(45).getFrequency());
		
		
		file = new File("test/in_05.txt");
		words = Utilities.tokenizeFile(file);
		f = TwoGramFrequencyCounter.computeTwoGramFrequencies(words);
		Utilities.printFrequencies(f);
		assertEquals(19,f.size());
		assertEquals("a m",f.get(0).getText());
		assertEquals(1,f.get(0).getFrequency());
		assertEquals("o dcbabcd",f.get(12).getText());
		assertEquals(1,f.get(12).getFrequency());
		assertEquals("u edcbaabcde",f.get(18).getText());
		assertEquals(1,f.get(18).getFrequency());
		
		file = new File("test/in_06.txt");
		words = Utilities.tokenizeFile(file);
		f = TwoGramFrequencyCounter.computeTwoGramFrequencies(words);
		Utilities.printFrequencies(f);
		assertEquals(1321,f.size());
		assertEquals("in the",f.get(0).getText());
		assertEquals(11,f.get(0).getFrequency());
		assertEquals("are also",f.get(12).getText());
		assertEquals(3,f.get(12).getFrequency());
		assertEquals("your lord",f.get(1320).getText());
		assertEquals(1,f.get(1320).getFrequency());
	}
/*
	
	Total item count: 25
	Unique item count: 25

	a b	1
	b c	1
	c d	1
	d e	1
	e f	1
	f g	1
	g h	1
	h i	1
	i j	1
	j k	1
	k l	1
	l m	1
	m n	1
	n o	1
	o p	1
	p q	1
	q r	1
	r s	1
	s t	1
	t u	1
	u v	1
	v w	1
	w x	1
	x y	1
	y z	1
	Total item count: 25
	Unique item count: 25

	aa bb	1
	bb cc	1
	cc dd	1
	dd ee	1
	ee ff	1
	ff gg	1
	gg hh	1
	hh ii	1
	ii jj	1
	jj kk	1
	kk ll	1
	ll mm	1
	mm nn	1
	nn oo	1
	oo pp	1
	pp qq	1
	qq rr	1
	rr ss	1
	ss tt	1
	tt uu	1
	uu vv	1
	vv ww	1
	ww xx	1
	xx yy	1
	yy zz	1
	Total item count: 271
	Unique item count: 248

	can not	3
	it is	3
	the people	3
	to the	3
	we can	3
	a great	2
	a new	2
	dedicated to	2
	for us	2
	here have	2
	in a	2
	of that	2
	shall not	2
	that nation	2
	that we	2
	to be	2
	we are	2
	which they	2
	a final	1
	a larger	1
	a portion	1
	above our	1
	add or	1
	advanced it	1
	ago our	1
	all men	1
	altogether fitting	1
	and dead	1
	and dedicated	1
	and proper	1
	and seven	1
	and so	1
	and that	1
	any nation	1
	are created	1
	are engaged	1
	are met	1
	as a	1
	battle field	1
	be dedicated	1
	be here	1
	before us	1
	birth of	1
	brave men	1
	brought forth	1
	but in	1
	but it	1
	by the	1
	can long	1
	can never	1
	cause for	1
	civil war	1
	come to	1
	conceived and	1
	conceived in	1
	consecrate we	1
	consecrated it	1
	continent a	1
	created equal	1
	dead shall	1
	dead we	1
	dead who	1
	dedicate a	1
	dedicate we	1
	dedicated can	1
	dedicated here	1
	detract the	1
	devotion that	1
	devotion to	1
	did here	1
	died in	1
	do this	1
	endure we	1
	engaged in	1
	equal now	1
	far above	1
	far so	1
	fathers brought	1
	field as	1
	field of	1
	final resting	1
	fitting and	1
	for the	1
	for those	1
	for which	1
	forget what	1
	forth on	1
	fought here	1
	four score	1
	freedom and	1
	from the	1
	from these	1
	full measure	1
	gave the	1
	gave their	1
	god shall	1
	government of	1
	great battle	1
	great civil	1
	great task	1
	ground the	1
	hallow this	1
	have a	1
	have come	1
	have consecrated	1
	have died	1
	have thus	1
	here but	1
	here dedicated	1
	here gave	1
	here highly	1
	here it	1
	here to	1
	highly resolve	1
	honored dead	1
	in liberty	1
	in vain	1
	increased devotion	1
	is altogether	1
	is for	1
	is rather	1
	it can	1
	it far	1
	larger sense	1
	last full	1
	liberty and	1
	little note	1
	live it	1
	lives that	1
	living and	1
	living rather	1
	long endure	1
	long remember	1
	measure of	1
	men are	1
	men living	1
	met on	1
	might live	1
	nation conceived	1
	nation might	1
	nation or	1
	nation so	1
	nation under	1
	never forget	1
	new birth	1
	new nation	1
	nobly advanced	1
	nor long	1
	not consecrate	1
	not dedicate	1
	not hallow	1
	not have	1
	not perish	1
	note nor	1
	now we	1
	of devotion	1
	of freedom	1
	of the	1
	on a	1
	on this	1
	or any	1
	or detract	1
	our fathers	1
	our poor	1
	people by	1
	people for	1
	people shall	1
	perish from	1
	place for	1
	poor power	1
	portion of	1
	power to	1
	proper that	1
	proposition that	1
	rather for	1
	rather to	1
	remaining before	1
	remember what	1
	resolve that	1
	resting place	1
	say here	1
	score and	1
	sense we	1
	seven years	1
	shall have	1
	should do	1
	so conceived	1
	so dedicated	1
	so nobly	1
	struggled here	1
	take increased	1
	task remaining	1
	testing whether	1
	that all	1
	that cause	1
	that field	1
	that from	1
	that government	1
	that that	1
	that these	1
	that this	1
	that war	1
	the brave	1
	the earth	1
	the great	1
	the last	1
	the living	1
	the proposition	1
	the unfinished	1
	the world	1
	their lives	1
	these dead	1
	these honored	1
	they did	1
	they gave	1
	they who	1
	this but	1
	this continent	1
	this ground	1
	this nation	1
	those who	1
	thus far	1
	to add	1
	to dedicate	1
	to that	1
	under god	1
	unfinished work	1
	us that	1
	us the	1
	us to	1
	vain that	1
	war testing	1
	war we	1
	we have	1
	we here	1
	we say	1
	we should	1
	we take	1
	what they	1
	what we	1
	whether that	1
	who fought	1
	who here	1
	who struggled	1
	will little	1
	work which	1
	world will	1
	years ago	1
	Total item count: 46
	Unique item count: 46

	0 1	1
	1 2	1
	2 3	1
	3 4	1
	4 5	1
	5 6	1
	6 78	1
	78 9	1
	9 0	1
	a few	1
	a way	1
	are embedded	1
	but if	1
	code then	1
	correctly this	1
	count correctly	1
	did it	1
	don t	1
	embedded in	1
	few words	1
	file is	1
	have the	1
	if you	1
	in this	1
	is a	1
	it right	1
	it won	1
	not you	1
	of testing	1
	or not	1
	right 0	1
	right code	1
	sentence but	1
	t count	1
	t have	1
	testing whether	1
	the right	1
	then it	1
	this file	1
	this sentence	1
	way of	1
	whether or	1
	won t	1
	words are	1
	you did	1
	you don	1
	Total item count: 19
	Unique item count: 19

	a m	1
	aa r	1
	baab s	1
	bab n	1
	cbaabc t	1
	cbabc o	1
	dcbaabcd u	1
	dcbabcd p	1
	edcbaabcde v	1
	edcbabcde q	1
	m bab	1
	n cbabc	1
	o dcbabcd	1
	p edcbabcde	1
	q aa	1
	r baab	1
	s cbaabc	1
	t dcbaabcd	1
	u edcbaabcde	1
	Total item count: 1512
	Unique item count: 1321

	in the	11
	palindromes in	10
	a palindrome	6
	of the	6
	in arabic	5
	may be	5
	the same	5
	7 2	4
	the first	4
	1 1	3
	2 7	3
	arabic language	3
	are also	3
	as a	3
	at least	3
	can be	3
	edit palindromes	3
	in a	3
	in tamil	3
	is a	3
	k l	3
	l k	3
	or line	3
	referred to	3
	the font	3
	the verse	3
	to the	3
	unit palindromes	3
	with the	3
	1 2	2
	2 1	2
	3 palindromes	2
	a canal	2
	a lindon	2
	a man	2
	a plan	2
	a toyota	2
	a word	2
	and are	2
	and in	2
	arabic literature	2
	are not	2
	are referred	2
	as letters	2
	as the	2
	at st	2
	be read	2
	bottom right	2
	by j	2
	canal panama	2
	character word	2
	consonants are	2
	create a	2
	d t	2
	d w	2
	da da	2
	da v	2
	dadas yak	2
	dadav dan	2
	dav dadav	2
	describe the	2
	edit the	2
	english palindromes	2
	examples include	2
	famous english	2
	for the	2
	form the	2
	found in	2
	go wandering	2
	h t	2
	his cordiality	2
	i m	2
	i saw	2
	i up	2
	in ancient	2
	in english	2
	in girum	2
	in persian	2
	in which	2
	include the	2
	is an	2
	is the	2
	it is	2
	j a	2
	la vadha	2
	line unit	2
	m w	2
	man a	2
	n rak	2
	of a	2
	of st	2
	on no	2
	one who	2
	palindrome is	2
	palindrome was	2
	palindromes are	2
	palindromic verses	2
	persian farsi	2
	plan a	2
	rabbaka fakabbir	2
	ran n	2
	ras hav	2
	reading the	2
	sak ran	2
	sator square	2
	such as	2
	t d	2
	t h	2
	that is	2
	that may	2
	the 19th	2
	the greek	2
	the honey	2
	the one	2
	the sator	2
	the second	2
	the sentence	2
	the word	2
	they can	2
	this article	2
	this palindrome	2
	to as	2
	to describe	2
	top left	2
	up la	2
	v da	2
	v has	2
	w d	2
	w m	2
	word or	2
	word the	2
	word unit	2
	yas dadas	2
	1 character	1
	1 classical	1
	1 famous	1
	1 history	1
	1 in	1
	1 musical	1
	1 palindromes	1
	11 couplets	1
	17th century	1
	1960s but	1
	19th canto	1
	19th century	1
	2 2	1
	2 3	1
	2 complex	1
	2 in	1
	2 lyrics2	1
	2 palindromes	1
	2 phrases2	1
	2 popular	1
	2 types	1
	2007 a	1
	3 comics2	1
	3 famous	1
	3 long	1
	3 names	1
	3 the	1
	36 40	1
	4 names2	1
	4 palindromes	1
	4 television	1
	4 word	1
	40 consontants	1
	5 molecular	1
	5 phrases	1
	6 a	1
	6 numbers2	1
	7 1	1
	7 3	1
	7 4	1
	7 acoustics	1
	7 madam	1
	74 3	1
	79 ad	1
	7th century	1
	8th century	1
	a car	1
	a cat	1
	a cave	1
	a circle	1
	a city	1
	a clover	1
	a continuation	1
	a devil	1
	a doctor	1
	a famous	1
	a fire	1
	a fly	1
	a graffito	1
	a hyphen	1
	a jar	1
	a lasagna	1
	a new	1
	a nut	1
	a patient	1
	a phrase	1
	a poem	1
	a salami	1
	a santa	1
	a sentence	1
	a vast	1
	a verse	1
	abbey orl	1
	abjad that	1
	able was	1
	abode is	1
	abraham ibn	1
	acoustics 2	1
	ad as	1
	adding citations	1
	additional citations	1
	adorned with	1
	again and	1
	again in	1
	ages 5	1
	alive erupts	1
	all calamities	1
	all of	1
	allies who	1
	alluding to	1
	also appears	1
	also contains	1
	also found	1
	also palindromes	1
	also the	1
	also to	1
	also9 references10	1
	although some	1
	am on	1
	amore roma	1
	an abjad	1
	an anonymous	1
	an example	1
	an inscription	1
	an inversion	1
	an orbit	1
	ancient sanskrit	1
	ancient sanskrit1	1
	ancient times	1
	and a	1
	and also	1
	and at	1
	and beseeches	1
	and down	1
	and dromos	1
	and gaits	1
	and hadleigh	1
	and incinerated	1
	and latin	1
	and line	1
	and no	1
	and refer	1
	and removed	1
	and several	1
	and so	1
	and spacing	1
	and stanzas	1
	and step	1
	and titles	1
	and translates	1
	and your	1
	andare in	1
	anom mata	1
	anonymous that	1
	another latin	1
	ans at	1
	appear in	1
	appears as	1
	arabic are	1
	are able	1
	are an	1
	are character	1
	are consumed	1
	are found	1
	are here	1
	are included	1
	are k	1
	are m	1
	are represented	1
	are shown	1
	are taken	1
	are usually	1
	arepo holds	1
	arepo tenet	1
	army which	1
	around the	1
	around was	1
	arranged into	1
	article by	1
	article needs	1
	as an	1
	as forward	1
	as go	1
	as i	1
	as in	1
	as maalai	1
	as palindromatic	1
	as rats	1
	as selfless	1
	as such	1
	as that	1
	as to	1
	as vishnu	1
	as word	1
	ash in	1
	at dulwich	1
	at herculaneum	1
	at nasa	1
	at night	1
	at the	1
	ate my	1
	avtan shebad	1
	b k	1
	b r	1
	back at	1
	back up	1
	backward as	1
	backward down	1
	backward to	1
	backwards contents	1
	backwards including	1
	baptismal fonts	1
	basilica of	1
	bats in	1
	battle ras	1
	be arranged	1
	be challenged	1
	be found	1
	be interpreted	1
	be more	1
	be referred	1
	be represented	1
	be translated	1
	beautiful one	1
	behavior of	1
	being the	1
	below in	1
	ben jonson	1
	beseeches him	1
	best of	1
	biological structures5	1
	biology2 6	1
	bodes and	1
	brought low	1
	buried by	1
	burned and	1
	but each	1
	but occasional	1
	but will	1
	by abraham	1
	by adding	1
	by ash	1
	by character	1
	by fire	1
	by magha	1
	by nandi	1
	by the	1
	byzantine greeks	1
	c e	1
	calamities but	1
	called the	1
	can clearly	1
	can i	1
	canto of	1
	capitalization and	1
	car or	1
	cat i	1
	cave mr	1
	century and	1
	century c	1
	century epic	1
	century the	1
	cf italian	1
	challenged and	1
	character by	1
	character the	1
	characters read	1
	church nottingham	1
	churches examples	1
	churches worlingworth	1
	circle cf	1
	citations for	1
	citations to	1
	city buried	1
	civic radar	1
	classes is	1
	classical music2	1
	clearly create	1
	clover if	1
	coined from	1
	college and	1
	column the	1
	comics2 7	1
	common palindromic	1
	community by	1
	complex palindromes	1
	complexity were	1
	composing literature	1
	computation theory6	1
	considerable complexity	1
	consist of	1
	consists of	1
	consonants only	1
	consontants are	1
	consontants only	1
	constantinople the	1
	constrained writing	1
	consumed by	1
	consumimur igni	1
	contained allies	1
	contains stanzas	1
	contended with	1
	content2 7	1
	contents 1	1
	continuation of	1
	continued in	1
	cordiality last	1
	cordiality lasts	1
	could be	1
	couplets occur	1
	crab inscription	1
	crabs alluding	1
	crabs such	1
	credited to	1
	cries of	1
	d egres	1
	da n	1
	da s	1
	dammit i	1
	dan ras	1
	dan the	1
	date back	1
	date to	1
	depends on	1
	despite all	1
	destroyed kama	1
	devil at	1
	devotee of	1
	devotional poetry	1
	diacritics palindromes	1
	diagonally sa	1
	different ways	1
	direction 1	1
	direction by	1
	discerned as	1
	disregarding vowels	1
	do geese	1
	doctor a	1
	doctor to	1
	doppelganger by	1
	down reading	1
	down up	1
	dromos way	1
	dulwich college	1
	e g	1
	e the	1
	each column	1
	each in	1
	each line	1
	each word	1
	earlier work	1
	earliest known	1
	easily discerned	1
	edit a	1
	edit arabic	1
	edit character	1
	edit some	1
	edit there	1
	edit transl	1
	effort the	1
	egres paris	1
	either forward	1
	either top	1
	elba 6	1
	elements whose	1
	eleven verses	1
	encyclopedia jump	1
	enemies sak	1
	english are	1
	english at	1
	english churches	1
	english palindromes2	1
	english palindromes8	1
	english writer	1
	engraving ps	1
	epic poem	1
	epigraf crab	1
	er venisraf	1
	ere i	1
	erupts a	1
	essex knapton	1
	et consumimur	1
	eva can	1
	evil a	1
	evil star	1
	example of	1
	example that	1
	examples are	1
	examples in	1
	examples of	1
	experimented with	1
	explained the	1
	external links	1
	ezra referring	1
	f k	1
	f l	1
	f y	1
	face n	1
	fact that	1
	fakabbir and	1
	fakabbir here	1
	falak but	1
	familiar palindromes	1
	famous example	1
	famous examples	1
	farsi 2	1
	farsi edit	1
	fi falak	1
	film see	1
	film this	1
	fire in	1
	fire volcano	1
	first four	1
	first letters	1
	first of	1
	first word	1
	fly landing	1
	follow proceed	1
	following churches	1
	font at	1
	font in	1
	font of	1
	fonts this	1
	for a	1
	for verification	1
	forth hence	1
	forward backward	1
	forward or	1
	forward some	1
	found as	1
	found from	1
	four and	1
	four different	1
	four lines	1
	free encyclopedia	1
	french and	1
	from at	1
	from either	1
	from letters	1
	from medieval	1
	from the	1
	from wikipedia	1
	fully reversible	1
	g eva	1
	gaits of	1
	geese see	1
	ghanta kavis	1
	giro go	1
	girum imus	1
	girum ire	1
	give a	1
	glorify quran	1
	glutton who	1
	go hang	1
	go in	1
	go strolling	1
	god ma	1
	god the	1
	graffito at	1
	greek letter	1
	greek phrase	1
	greek roots	1
	greeks often	1
	h l	1
	h w	1
	ha s	1
	ha v	1
	hadleigh suffolk	1
	halachic question	1
	hang a	1
	harlow essex	1
	has rak	1
	has ran	1
	hav contained	1
	hav v	1
	have heard	1
	hawlin wahal	1
	heard in	1
	hebrew palindrome	1
	help improve	1
	hence it	1
	herculaneum a	1
	here for	1
	here only	1
	here r	1
	here reading	1
	him shiva	1
	history 1	1
	history edit	1
	hog and	1
	holds with	1
	honey makes	1
	honey treif	1
	honey was	1
	horizontally or	1
	however taking	1
	hyphen indicates	1
	i am	1
	i ere	1
	i stab	1
	ibn ezra	1
	if alive	1
	if read	1
	igni we	1
	ignored although	1
	improve this	1
	impurities palindromic	1
	imus nocte	1
	in an	1
	in each	1
	in either	1
	in four	1
	in french	1
	in giro	1
	in honey	1
	in iran	1
	in it	1
	in kanda	1
	in latin	1
	in literature	1
	in madhava	1
	in mahavidvaan	1
	in many	1
	in nixon	1
	in palindromes	1
	in sanskrit	1
	in that	1
	incinerated perashnu	1
	include amore	1
	included here	1
	including vowels	1
	incomparable god	1
	indicates a	1
	inscribed the	1
	inscription or	1
	inscription that	1
	instead of	1
	instead they	1
	instruments v	1
	interpreted the	1
	into a	1
	inversion of	1
	iran have	1
	ire is	1
	is as	1
	is from	1
	is fully	1
	is in	1
	is karkinik	1
	is likely	1
	is literally	1
	is only	1
	is remarkable	1
	is sirkazhi	1
	is swimming	1
	is translated	1
	it a	1
	it can	1
	it refers	1
	it the	1
	it yields	1
	italian andare	1
	its properties	1
	jar of	1
	jonson in	1
	jump to	1
	k b	1
	k f	1
	k in	1
	k ra	1
	k ya	1
	ka ra	1
	ka sa	1
	kaaronap puranam	1
	kama whose	1
	kanchi puranam	1
	kanda style	1
	karkinik epigraf	1
	karkinoi crabs	1
	kavis in	1
	kayak reviver	1
	kir t	1
	knapton norfolk	1
	known english	1
	known palindromic	1
	kosher another	1
	kullu mawaddatihi	1
	kullun fi	1
	l being	1
	l f	1
	l h	1
	l m	1
	l w	1
	landing in	1
	language 1	1
	language edit	1
	language is	1
	lasagna hog	1
	last consonants	1
	last four	1
	lasts despite	1
	latin date	1
	latin palindrome	1
	latin sator	1
	least are	1
	least the	1
	least to	1
	left as	1
	left to	1
	letter palindromes	1
	letter psi	1
	letters consontants	1
	letters form	1
	letters instead	1
	letters of	1
	letters vowels	1
	level rotor	1
	likely that	1
	likulli hawlin	1
	lindon in	1
	lindon these	1
	line as	1
	line is	1
	line unit2	1
	lines are	1
	linguistics community	1
	links history	1
	literal go	1
	literally could	1
	literature 1	1
	literature classes	1
	literature edit	1
	literature in	1
	live on	1
	lived around	1
	lived as	1
	london and	1
	long palindromes4	1
	lord glorify	1
	low the	1
	ludgate london	1
	lyrics2 7	1
	m a	1
	m l	1
	m m	1
	m mad	1
	m nan	1
	m with	1
	ma is	1
	maalai maatru	1
	maatru the	1
	mad a	1
	madam malayalam	1
	madhava shivagnana	1
	magha it	1
	mahavidvaan meenakshi	1
	makes the	1
	malayalam and	1
	many english	1
	martin ludgate	1
	mary s	1
	mata m	1
	material may	1
	mawaddatihi tadumu	1
	mawaddatuhu tadumu	1
	may 2007	1
	meaning may	1
	medieval rather	1
	meenakshi sundaram	1
	menin s	1
	metal worm	1
	mid letter	1
	middle ages	1
	ministry scale	1
	molecular biology2	1
	more easily	1
	most familiar	1
	most students	1
	moths it	1
	mounts contended	1
	movement of	1
	mr owl	1
	music 2	1
	music2 7	1
	musical content2	1
	musical instruments	1
	my metal	1
	n da	1
	n dav	1
	n n	1
	n pson	1
	na na	1
	na ra	1
	names and	1
	names2 5	1
	nan psin	1
	nandi ghanta	1
	nasa punctuation	1
	navigation search	1
	needs additional	1
	new stanza	1
	night and	1
	nitba er	1
	nixon composing	1
	no evil	1
	no pets	1
	no x	1
	nocte et	1
	non english	1
	non kosher	1
	noon kayak	1
	norfolk st	1
	not create	1
	not only	1
	not part	1
	not visible	1
	note a	1
	nottingham and	1
	number or	1
	numbers2 7	1
	nut for	1
	occasional examples	1
	occur in	1
	of common	1
	of considerable	1
	of constrained	1
	of crabs	1
	of each	1
	of his	1
	of impurities	1
	of moths	1
	of mounts	1
	of reversal	1
	of same	1
	of symbols	1
	of their	1
	of these	1
	of tuna	1
	often consist	1
	often inscribed	1
	on a	1
	on baptismal	1
	on re	1
	one adorned	1
	only consonants	1
	only disregarding	1
	only so	1
	only the	1
	only which	1
	opera rotas	1
	or a	1
	or bottom	1
	or diagonally	1
	or elements	1
	or other	1
	or reverse	1
	or sentence	1
	or simply	1
	or vertically	1
	or wandering	1
	orbit is	1
	orl ans	1
	other sequence	1
	out consonants	1
	owl ate	1
	palin again	1
	palindromatic a	1
	palindrome and	1
	palindrome called	1
	palindrome from	1
	palindrome however	1
	palindrome in	1
	palindrome transl	1
	palindrome wash	1
	palindrome we	1
	palindrome with	1
	palindromes and	1
	palindromes appear	1
	palindromes date	1
	palindromes edit	1
	palindromes film	1
	palindromes is	1
	palindromes of	1
	palindromes often	1
	palindromes redirects	1
	palindromes respectively	1
	palindromes were	1
	palindromes where	1
	palindromes2 4	1
	palindromes4 biological	1
	palindromes8 see	1
	palindromic words	1
	panama 7	1
	panama and	1
	paris at	1
	part of	1
	patient a	1
	patient so	1
	perashnu ra	1
	pets include	1
	phenomenon is	1
	phrase number	1
	phrase or	1
	phrase to	1
	phrases edit	1
	phrases2 3	1
	pillai s	1
	plays the	1
	please help	1
	poem credited	1
	poem doppelganger	1
	poem i	1
	poem was	1
	poetry 2	1
	poetry edit	1
	poetry of	1
	poetry1 4	1
	popular music	1
	popularized in	1
	practice was	1
	proceed them	1
	properties may	1
	property is	1
	ps with	1
	psi on	1
	psin engraving	1
	pson anom	1
	punctuation capitalization	1
	puranam 3	1
	puranam and	1
	pure evil	1
	question as	1
	quran 36	1
	quran 74	1
	quran edit	1
	quran1 1	1
	r b	1
	r can	1
	ra avtan	1
	ra ka	1
	ra n	1
	ra na	1
	ra s	1
	racecar redder	1
	radar level	1
	rak sa	1
	rak sak	1
	rak yas	1
	ran dav	1
	rather than	1
	rats live	1
	re reading	1
	read backward	1
	read backwards	1
	read forward	1
	read the	1
	reading depends	1
	reads in	1
	reads rabbaka	1
	reads the	1
	recreational linguistics	1
	redder madam	1
	redirects here	1
	refer there	1
	references10 external	1
	referring to	1
	refers to	1
	reliable sources	1
	relished battle	1
	remarkable for	1
	removed may	1
	represented as	1
	represented using	1
	respectively 4	1
	reversal is	1
	reverse direction	1
	reversible the	1
	reviver racecar	1
	rid the	1
	right or	1
	right to	1
	rjun ya	1
	roma a	1
	roots palin	1
	rotas the	1
	rotor noon	1
	runs thus	1
	s a	1
	s abbey	1
	s church	1
	s da	1
	s ha	1
	s kanchi	1
	s ra	1
	s thirunaagaik	1
	s ya	1
	sa k	1
	sa ka	1
	sa note	1
	said to	1
	saint sambandhar	1
	sak yas	1
	salami i	1
	sambandhar who	1
	same backward	1
	same property	1
	same text	1
	same way	1
	same word	1
	same work	1
	sanskrit edit	1
	sanskrit poem	1
	sanskrit poetry	1
	sanskrit1 3	1
	santa lived	1
	sator arepo	1
	saw a	1
	saw elba	1
	scale types	1
	search palindromes	1
	second letters	1
	second word	1
	see also9	1
	see god	1
	see palindromes	1
	selfless as	1
	semordnilap7 non	1
	semordnilaps such	1
	sentence backwards	1
	sentence e	1
	sentence reads	1
	sentence written	1
	sequence of	1
	several in	1
	shaivism saint	1
	shebad vash	1
	shiva as	1
	shiva to	1
	shivagnana yogi	1
	shown below	1
	simply karkinoi	1
	single greek	1
	sins not	1
	sirkazhi who	1
	snakes the	1
	so forth	1
	so or	1
	so patient	1
	so that	1
	some examples	1
	some such	1
	some well	1
	sophia constantinople	1
	sources unsourced	1
	sower arepo	1
	spacing are	1
	spacing famous	1
	square consists	1
	square palindromes	1
	square that	1
	st martin	1
	st mary	1
	st menin	1
	st sophia	1
	st stephen	1
	stab bats	1
	stanza semordnilaps	1
	stanza translates	1
	stanzas are	1
	stanzas in	1
	stanzas that	1
	star and	1
	step on	1
	stephen d	1
	striving enemies	1
	strolling or	1
	structures5 computation	1
	students in	1
	style palindromes	1
	such stanzas	1
	such they	1
	suffolk harlow	1
	suffolk palindromes	1
	sugar with	1
	sundaram pillai	1
	swimming quran	1
	symbols or	1
	t rjun	1
	tadumu and	1
	tadumu likulli	1
	taken from	1
	taking out	1
	tamil as	1
	tamil poetry	1
	tamil poetry1	1
	television 3	1
	tenet opera	1
	text back	1
	text if	1
	than ancient	1
	that army	1
	that follow	1
	that its	1
	that most	1
	that reads	1
	that the	1
	that this	1
	that year	1
	the 17th	1
	the 1960s	1
	the 7th	1
	the 8th	1
	the basilica	1
	the beautiful	1
	the behavior	1
	the best	1
	the bodes	1
	the cries	1
	the devotee	1
	the devotional	1
	the earlier	1
	the earliest	1
	the english	1
	the face	1
	the fact	1
	the film	1
	the following	1
	the free	1
	the glutton	1
	the halachic	1
	the hebrew	1
	the incomparable	1
	the last	1
	the literal	1
	the mid	1
	the middle	1
	the ministry	1
	the most	1
	the movement	1
	the palindrome	1
	the phenomenon	1
	the poem	1
	the quran	1
	the quran1	1
	the recreational	1
	the shaivism	1
	the single	1
	the sins	1
	the sower	1
	the spacing	1
	the stanza	1
	the sugar	1
	the text	1
	the unit	1
	the up	1
	the veena	1
	the wheels	1
	the written	1
	their various	1
	them examples	1
	theory6 semordnilap7	1
	there are	1
	there is	1
	these are	1
	these eleven	1
	they are	1
	thirunaagaik kaaronap	1
	this practice	1
	this sanskrit	1
	thus it	1
	times byzantine	1
	titles 2	1
	to 79	1
	to an	1
	to be	1
	to bottom	1
	to doctor	1
	to give	1
	to his	1
	to in	1
	to mawaddatuhu	1
	to navigation	1
	to reliable	1
	to rid	1
	to shiva	1
	to top	1
	to weigh	1
	to whether	1
	toyota go	1
	toyota s	1
	transl kullun	1
	transl rabbaka	1
	translated as	1
	translated to	1
	translates as	1
	translates to	1
	transliterates to	1
	treif non	1
	tuna do	1
	types 2	1
	types edit	1
	unit edit	1
	unit of	1
	unit2 2	1
	unsourced material	1
	up again	1
	up and	1
	up or	1
	using diacritics	1
	usually ignored	1
	v ha	1
	v v	1
	vadha also	1
	vadha by	1
	various striving	1
	vash nitba	1
	vast pure	1
	veena the	1
	venisraf by	1
	verification please	1
	verse in	1
	verse reads	1
	verse they	1
	verse transliterates	1
	verses 11	1
	verses are	1
	verses runs	1
	vertically from	1
	vishnu and	1
	visible as	1
	volcano dammit	1
	vowels are	1
	vowels that	1
	vowels would	1
	w h	1
	w l	1
	wahal kullu	1
	wandering around	1
	wandering at	1
	wandering instead	1
	was burned	1
	was coined	1
	was continued	1
	was found	1
	was i	1
	was it	1
	was said	1
	was written	1
	wash the	1
	way direction	1
	way in	1
	ways horizontally	1
	we explained	1
	we go	1
	weigh the	1
	well known	1
	were experimented	1
	were popularized	1
	wheels it	1
	where the	1
	whether a	1
	which are	1
	which each	1
	which in	1
	which relished	1
	who also	1
	who brought	1
	who destroyed	1
	who is	1
	who lived	1
	who plays	1
	whose abode	1
	whose meaning	1
	wikipedia the	1
	will all	1
	with effort	1
	with in	1
	with l	1
	with musical	1
	with snakes	1
	word and	1
	word form	1
	word palindrome	1
	word phrase	1
	word so	1
	word square	1
	words civic	1
	work i	1
	work kir	1
	worlingworth suffolk	1
	worm was	1
	would not	1
	writer ben	1
	writing the	1
	written by	1
	written characters	1
	written in	1
	x in	1
	y f	1
	ya k	1
	ya s	1
	ya this	1
	yak and	1
	yak sak	1
	year this	1
	yields the	1
	yogi s	1
	your lord	1
*/

}
